//
//                            3D WireFrame Rotation
//                               Jessica Lee
//

import java.awt.*;
import java.applet.Applet;
import java.lang.Math;
import trig;
import quad;
import verts;


//
//  This class is the Tetra object
//
public class Tetra{
    static trig T = new trig();               
    int x=0,y=0,z=10000 * 100;                
    int xoffset=150,yoffset=150;
    int xrot=10,yrot=10,zrot=10;                 
    int xrotadd=10, yrotadd=10, zrotadd=10;
    int bred=0, bgreen=0, bblue=0;
    int fred=120, fgreen=160, fblue=0;
    int len=100;
    int size=10;

    int permverts[];
    verts A;
    quad face[];

    Tetra (int s){
        int xyz[] =new int[3];
        int i,j,cntr=0;

        size =s;
        permverts = new int[15];
        face = new quad[5];

        permverts[0] = 0;
        permverts[1] = (10+size)*(len/10);
        permverts[2] = 0;
        permverts[3] = (10+size)*(len/10);
        permverts[4] = -(10+size)*(len/10);
        permverts[5] = (10+size)*(len/10);
        permverts[6] =  (10+size)*(len/10);
        permverts[6] = (10+size)*(len/10);
        permverts[7] = -(10+size)*(len/10);
        permverts[8] = -(10+size)*(len/10);
        permverts[9] = -(10+size)*(len/10);
        permverts[10] = -(10+size)*(len/10);
        permverts[11] = -(10+size)*(len/10);
        permverts[12] = -(10+size)*(len/10);
        permverts[13] = -(10+size)*(len/10);
        permverts[14] = (10+size)*(len/10);
    
        face[0]= new quad(0,1,2,0);
        face[1]= new quad(0,2,3,0);
        face[2]= new quad(0,3,4,0);
        face[3]= new quad(0,1,4,0);
        face[4]= new quad(1,2,3,4);
   
        A=new verts(permverts);
    }

    void remove(Graphics g){
        int i;
        for(i=0;i<5;i++){
        face[i].draw(A.tempverts,g,1,bred, bgreen, bblue, bred, bgreen, bblue);
        }
    }

    public void draw(Graphics g){
        int i;

        xrot += xrotadd;
        if (xrot > 1023) xrot -= 1024;
        yrot += yrotadd;
        if (yrot > 1023) yrot -= 1024;
        zrot += zrotadd;
        if (zrot > 1023) zrot -= 1024;

        A.rotate(xrot,yrot,zrot,T);
        A.perspective(x,y,z,xoffset,yoffset);

        for(i=0;i<5;i++){
        face[i].draw(A.tempverts,g,1,fred+(i*7), fgreen+(i*7), fblue+(i*7), bred, bgreen, bblue);
        }

    }
}





