//
//                            3D Rotation
//                                  V1.00
//                         Copyright 1996 Jessica Lee
//
import java.awt.*;
import java.applet.Applet;
import java.lang.Math;
import trig;



//
//  The verts class preforms operations on the verticies of a vector object
//
public class verts{
    int permverts[];
    int tempverts[];

    verts(int inputverts[]){
        int i;
        if(inputverts.length==0){
            System.out.println("Error in verts constructor - no input");
            return;
        }
        permverts = new int[inputverts.length];
        tempverts = new int[inputverts.length];

        for(i=0;i<inputverts.length;i++){
            permverts[i]=inputverts[i];
        }
    }

    public void rotate(int xrot, int yrot, int zrot, trig T){
        int i,j=permverts.length;
        int X,Y,Z;


        for(i=0;i<j;i+=3){

            X=T.cost[yrot] * (permverts[i]) - T.sint[yrot] * permverts[i+2];
            Z=T.sint[yrot] * (permverts[i]) + T.cost[yrot] * permverts[i+2];

            tempverts[i]= (T.cost[zrot] * X/1024)  + T.sint[zrot] * permverts[i+1];
            Y=T.cost[zrot] * permverts[i+1] - (T.sint[zrot] * X/1024);

            tempverts[i+2]=(T.cost[xrot] * Z/1024) - (T.sint[xrot] * Y/1024);
            tempverts[i+1]=(T.sint[xrot] * Z/1024) + (T.cost[xrot] * Y/1024);


        }

/*
        System.out.println("verts = ");
        for(i=0;i<tempverts.length;i+=3){
            System.out.println("verts = "+tempverts[i]+" "+tempverts[i+1]+" "+tempverts[i+2]);
        }
*/

    }

    public void perspective(int x, int y, int z, int xoffset, int yoffset){
        int i,j=tempverts.length;

        for(i=0;i<j;i+=3){
            tempverts[i]+=x;
            tempverts[i+1]+=y;
            tempverts[i+2]+=z;

            tempverts[i]= (xoffset) + 250 * tempverts[i] / (tempverts[i+2] );
            tempverts[i+1] = (yoffset) + 250 * tempverts[i+1] / (tempverts[i+2]);


        }
    }


}








