//
//                            3D Rotation
//                                  V1.00
//                         Copyright 1996 Jessica Lee
//
import java.awt.*;
import java.applet.Applet;
import java.lang.Math;
import verts;


//
//  This is the quad class - it handles each visible face
//
public class quad {
    int pnt1,pnt2,pnt3,pnt4;
    int xpnts[] = new int[5];
    int ypnts[] = new int[5];
    int numpnts = 5;
    int visarray[] = new int[4];


    quad(int idx1, int idx2, int idx3, int idx4){
        pnt1 = idx1 * 3;
        pnt2 = idx2 * 3;
        pnt3 = idx3 * 3;
        pnt4 = idx4 * 3;
    }

    private int visibility(int tempverts[]){
        visarray[0] = tempverts[pnt1] - tempverts[pnt3];
        visarray[1] = tempverts[pnt1+1] - tempverts[pnt3+1];
        visarray[2] = tempverts[pnt2] - tempverts[pnt3];
        visarray[3] = tempverts[pnt2+1] - tempverts[pnt3+1];

     //   return(visarray[0] * visarray[3] - visarray[1] * visarray[2]);
        return 1;
    }

    public void draw(int tempverts[], Graphics g, int transparent, int red, int green, int blue, int bred, int bgreen, int bblue){

        if(visibility(tempverts) < 0) return;

        xpnts[0]=tempverts[pnt1];
        ypnts[0]=tempverts[pnt1+1];
        xpnts[1]=tempverts[pnt2];
        ypnts[1]=tempverts[pnt2+1];
        xpnts[2]=tempverts[pnt3];
        ypnts[2]=tempverts[pnt3+1];
        xpnts[3]=tempverts[pnt4];
        ypnts[3]=tempverts[pnt4+1];
        xpnts[4]=tempverts[pnt1];
        ypnts[4]=tempverts[pnt1+1];

        g.setColor(new Color(red, green, blue));

        if(transparent==0){
            g.fillPolygon(xpnts,ypnts,5);
            g.setColor(new Color(bred, bgreen, bblue));
            g.drawPolygon(xpnts,ypnts,5);
        }
        else{
          //  g.fillPolygon(xpnts,ypnts,5);
            g.setColor(new Color(red, green, blue));
            g.drawPolygon(xpnts,ypnts,5);
        }
    }
}




