//
//                            3D WireFrame Rotation
//                               Jessica Lee 1996
//

import java.awt.*;
import java.applet.Applet;
import java.lang.Math;
import trig;
import quad;
import verts;


//
//  This class is the Cube object
//
public class Cube{
    static trig T = new trig();               
    int x=0,y=0,z=10000 * 100;                
    int xoffset=150,yoffset=150;
    int xrot=10,yrot=10,zrot=10;                 
    int xrotadd=10, yrotadd=10, zrotadd=10;
    int bred=0, bgreen=0, bblue=0;
    int fred=100, fgreen=50, fblue=180;
    int size=10;
    int len=100;

    int permverts[];
    verts A;
    quad face[];

    Cube (int s){
        int xyz[] =new int[3];
        int i,j,cntr=0;

        size = s;
        permverts = new int[24];
        face = new quad[6];

        permverts[0] = (len/10)*(10+size);
        permverts[1] = (len/10)*(10+size);
        permverts[2] = (len/10)*(10+size);
        permverts[3] = (len/10)*(10+size);
        permverts[4] = 0;
        permverts[5] = (len/10)*(10+size);
        permverts[6] = (len/10)*(10+size);
        permverts[7] = 0;
        permverts[8] = 0;
        permverts[9] = (len/10)*(10+size);
        permverts[10] = (len/10)*(10+size);
        permverts[11] = 0;
        permverts[12] = 0;
        permverts[13] = (len/10)*(10+size);
        permverts[14] = 0;
        permverts[15] = 0;
        permverts[16] = (len/10)*(10+size);
        permverts[17] = (len/10)*(10+size);
        permverts[18] = 0;
        permverts[19] = 0;
        permverts[20] = (len/10)*(10+size);
        permverts[21] = 0;
        permverts[22] = 0;
        permverts[23] = 0;

       for(i=0;i<8;i++){
          permverts[i]=permverts[i]-(1/2)*(len*size);
          permverts[i+1] =permverts[i+1]+(1/2)*(len*size);
          permverts[i+2]=permverts[i+2]-(1/2)*(len*size);
        }

        face[0]= new quad(0,1,2,3);
        face[1]= new quad(0,3,4,5);
        face[2]= new quad(3,4,7,2);
        face[3]= new quad(4,5,6,7);
        face[4]= new quad(0,1,6,5);
        face[5]= new quad(1,2,7,6);
  
        A=new verts(permverts);
    }

    void remove(Graphics g){
        int i;
        for(i=0;i<6;i++){
        face[i].draw(A.tempverts,g,1,bred, bgreen, bblue, bred, bgreen, bblue);
        }
    }

    public void draw(Graphics g){
        int i;

        xrot += xrotadd;
        if (xrot > 1023) xrot -= 1024;
        yrot += yrotadd;
        if (yrot > 1023) yrot -= 1024;
        zrot += zrotadd;
        if (zrot > 1023) zrot -= 1024;

        A.rotate(xrot,yrot,zrot,T);
        A.perspective(x,y,z,xoffset,yoffset);

        for(i=0;i<6;i++){
        face[i].draw(A.tempverts,g,1,fred+(i*7), fgreen+(i*7), fblue+(i*7), bred, bgreen, bblue);
        }

    }
}



