//
//                            3D Rotation
//                                  V1.00
//                         Copyright 1996 Jessica Lee
//
import java.awt.*;
import java.applet.Applet;
import java.lang.Math;

//
//  This is the trig class - it generates trig tables for rotations
//    I am using tables here and 10bit precision to eliminate floating
//    point calculations
//
public class trig {
    public static final int NUMANGLES = 1024;
    public static final int PRECISION = 1024;

    public static int sint[] = new int[NUMANGLES];
    public static int cost[] = new int[NUMANGLES];


    trig(){
        int cntr;
        double temp;
        for(cntr=0;cntr<NUMANGLES;cntr++)
            sint[cntr] = (int) (0.5+PRECISION * Math.sin(cntr*2.0*Math.PI/NUMANGLES));

        for(cntr=0;cntr<NUMANGLES;cntr++)
            cost[cntr] = (int) (0.5+PRECISION * Math.cos(cntr*2.0*Math.PI/NUMANGLES));

    }
}
